
org  0x7c00           ;//    
jmp  @start           ;//   -

disk          db  0   ;//    

header        db  '*** [ CodebyOS ] *** : ver0.1x Build 04.2025'
hLen          =   $ - header
bootDev       db  ' Boot device:'
bootDevLen    =   $ - bootDev
floppy        db  ' Floppy(A) 1.44 Mb'
floppyLen     =   $ - floppy
hdd           db  ' Hard #'
hddLen        =   $ - hdd
error         db  ' Error! Boot partition not found'
errorLen      =   $ - error
loadOs        db  ' Load OS into memory? y/n...'
loadLen       =   $ - loadOs

;//      INT-13h (. .417)
;//---------------------------------------------------------------
DiskPacket:
SizeOf        dw  16      ;//  
Counter       dw  0       ;//   R/W
BuffOffs      dw  0       ;//   -,
BuffSeg       dw  0       ;// ...  .
StartLBA      dd  0,0     ;// 64- LBA  -

align    4
@start:  mov    [disk],dl    ;//<---------  !

         xor    ax,ax        ;//   
         mov    ds,ax        ;//   !
         mov    es,ax
         mov    ss,ax
         mov    sp,0x7c00    ;//   SS:SP
         sub    sp,4         ;//

;//  - 8025   
         mov    ax,3
         int    10h
         mov    ah,1
         mov    cx,0x2000
         int    10h

;//     
         push   es 0 0xb800    ;// 0xb800 =  /
         pop    es di          ;// ES:DI =     
         mov    cx,80          ;//    
         mov    al,' '         ;//  
         mov    ah,01001111b   ;// :     
         rep    stosw          ;//  AX  /!

;//    
         mov    si,header      ;// 
         mov    cx,hLen        ;//  
         mov    di,36          ;//   
@@:      lodsb                 ;//    DS:SI  1-,
         stosw                 ;//    / ES:DI  2- ( )
         loop   @b             ;//  -..

;//      
         mov    ah,00110000b   ;// :   
         mov    di,164         ;//   : (80*2)+4 = (2)
         mov    al,' '         ;//  
         mov    bp,7           ;//   
@@:      mov    cx,10          ;//   
         rep    stosw          ;//  !
         add    di,2           ;//   
         dec    bp             ;//  -1
         jnz    @b             ;// ,     

;//     
         mov    ah,00000111b   ;//   
         mov    di,(160*4)     ;//    = (4)
         mov    si,bootDev     ;//    
         mov    cx,bootDevLen  ;//  
@@:      lodsb                 ;//   !
         stosw
         loop   @b

         mov    si,floppy      ;//    "Floppy"
         mov    cx,floppyLen   ;//
         cmp    [disk],0       ;//  ?
         je     @f             ;//  - 
         mov    si,hdd         ;// :     "HDD"
         mov    cx,hddLen      ;//
@@:      lodsb                 ;// !
         stosw
         loop   @b

         pop    es             ;//  ES (  int-13h)
         cmp    [disk],0       ;//  ?
         je     @fdd           ;//  - 
                               ;// :   = HDD
;//-------------------------------------------------
;//       

         mov    si,0x01BE        ;//     HDD
         mov    cx,4             ;//    
@find:   cmp    byte[si],0x80    ;//    !
         je     @ok              ;//  ..
         add    si,0x10          ;// :   .  
         loop   @find            ;//  -..

         push   es 0xb800        ;// ! Boot   !
         pop    es
         mov    si,error
         mov    cx,errorLen
         mov    di,(160*5)
@@:      lodsb
         stosw
         loop   @b
         pop    es
         jmp    $

;//    -     
;//   -    INT-13h
@ok:     mov    eax,dword[si+8]     ;//     "LBA-Start"
         mov    [StartLBA],eax      ;//    -
         mov    [Counter],1         ;//    (   )
         mov    ax,ds               ;//
         mov    [BuffSeg],ax        ;//   ,
         mov    [BuffOffs],0x600    ;// ...   = 0000:0600

         mov    ah,0x42             ;//  42h =   HDD  
         mov    dl,[disk]           ;//  
         mov    si,DiskPacket       ;//   -
         int    13h                 ;//    !

;//     
@fdd:    push   es 0xb800           ;//  -
         pop    es
         mov    si,loadOs           ;//  
         mov    cx,loadLen          ;//  
         mov    di,(160*5)          ;//    = (5)
@@:      lodsb                      ;// !
         stosw
         loop   @b
         pop    es

;//  `   ,  
         jmp    $

;//-------------------------------------------------------------------
;//      512- 
;//-------------------------------------------------------------------
times    510-($-$$) db 0
dw       0xAA55           ;//<---    Boot- 55AAh







